const char HTMLForest_css[] = 
  R"x(body {)x" "\n"
  R"x(  position: absolute;)x" "\n"
  R"x(  top: 0;)x" "\n"
  R"x(  bottom: 0;)x" "\n"
  R"x(  right: 0;)x" "\n"
  R"x(  left: 0;)x" "\n"
  R"x()x" "\n"
  R"x(  display: flex;)x" "\n"
  R"x(  align-items: stretch;)x" "\n"
  R"x(  margin: 0;)x" "\n"
  R"x(  font-family: sans-serif;)x" "\n"
  R"x(  white-space: nowrap;)x" "\n"
  R"x(  height: 100%;)x" "\n"
  R"x(})x" "\n"
  R"x(body > * {)x" "\n"
  R"x(  overflow-y: auto; /* Scroll sections independently*/)x" "\n"
  R"x(  margin: 0;)x" "\n"
  R"x(})x" "\n"
  R"x()x" "\n"
  R"x(#code {)x" "\n"
  R"x(  font-size: 18px;)x" "\n"
  R"x(  line-height: 36px;)x" "\n"
  R"x(  flex-grow: 1;)x" "\n"
  R"x(  padding-right: 10em; /* Leave space for #info */)x" "\n"
  R"x(})x" "\n"
  R"x(#code span {)x" "\n"
  R"x(  padding: 9px 0; /* No "gaps" between lines due to line-height */)x" "\n"
  R"x(})x" "\n"
  R"x(.node.ambiguous::before, .ancestors.ambiguous::after, .tree-node.ambiguous > header::after {)x" "\n"
  R"x(  content: /*the thinking man's emoji*/'\01F914';)x" "\n"
  R"x(})x" "\n"
  R"x()x" "\n"
  R"x(#info {)x" "\n"
  R"x(  position: fixed;)x" "\n"
  R"x(  right: 2em;)x" "\n"
  R"x(  top: 1em;)x" "\n"
  R"x(  width: 25em;)x" "\n"
  R"x(  border: 1px solid black;)x" "\n"
  R"x(  min-height: 20em;)x" "\n"
  R"x(  background-color: whiteSmoke;)x" "\n"
  R"x(  overflow-x: clip;)x" "\n"
  R"x(  box-shadow: 3px 3px 5px rgba(0,0,0,0.2);)x" "\n"
  R"x(})x" "\n"
  R"x(#info header {)x" "\n"
  R"x(  background-color: black;)x" "\n"
  R"x(  color: white;)x" "\n"
  R"x(  font-size: larger;)x" "\n"
  R"x(  padding: 0.5em;)x" "\n"
  R"x(})x" "\n"
  R"x(#info.ambiguous header { background-color: #803; })x" "\n"
  R"x(#info.sequence header { background-color: darkBlue; })x" "\n"
  R"x(#info.terminal header { background-color: darkGreen; })x" "\n"
  R"x(#info.opaque header { background-color: orangeRed; })x" "\n"
  R"x(#i_kind {)x" "\n"
  R"x(  float: right;)x" "\n"
  R"x(  font-size: small;)x" "\n"
  R"x(})x" "\n"
  R"x(#info section {)x" "\n"
  R"x(  padding: 0.5em;)x" "\n"
  R"x(  border-top: 1px solid lightGray;)x" "\n"
  R"x(  overflow-x: auto;)x" "\n"
  R"x(})x" "\n"
  R"x(#i_ancestors { font-size: small; })x" "\n"
  R"x()x" "\n"
  R"x(#tree {)x" "\n"
  R"x(  flex-grow: 0;)x" "\n"
  R"x(  min-width: 20em;)x" "\n"
  R"x(  margin-right: 1em;)x" "\n"
  R"x(  border-right: 1px solid darkGray;)x" "\n"
  R"x(  background-color: azure;)x" "\n"
  R"x(  font-size: small;)x" "\n"
  R"x(  overflow-x: auto;)x" "\n"
  R"x(  resize: horizontal;)x" "\n"
  R"x(})x" "\n"
  R"x(#tree ul {)x" "\n"
  R"x(  margin: 0;)x" "\n"
  R"x(  display: inline-block;)x" "\n"
  R"x(  padding-left: 6px;)x" "\n"
  R"x(  border-left: 1px solid rgba(0,0,0,0.2);)x" "\n"
  R"x(  list-style: none;)x" "\n"
  R"x(})x" "\n"
  R"x(#tree > ul { border-left: none; })x" "\n"
  R"x(.tree-node.selected > header .name { font-weight: bold; })x" "\n"
  R"x(.tree-node.terminal .name { font-family: monospace; })x" "\n"
  R"x(.tree-node.ambiguous > header .name { color: #803; font-weight: bold; })x" "\n"
  R"x(.tree-node.sequence > header .name { color: darkBlue; })x" "\n"
  R"x(.tree-node.terminal > header .name { color: darkGreen; })x" "\n"
  R"x(.tree-node.opaque > header .name { color: orangeRed; })x" "\n"
  R"x()x" "\n"
  R"x(.selected { outline: 1px dashed black; })x" "\n"
  R"x(.abbrev { opacity: 50%; })x" "\n"
  R"x(.abbrev::after { content: '~'; })x" "\n"
  R"x(.opaque { background-color: bisque; })x" "\n"
  R"x()x" "\n"
  ;
const char HTMLForest_js[] = 
  R"x(// The global map of forest node index => NodeView.)x" "\n"
  R"x(views = [];)x" "\n"
  R"x(// NodeView is a visible forest node.)x" "\n"
  R"x(// It has an entry in the navigation tree, and a span in the code itself.)x" "\n"
  R"x(// Each NodeView is associated with a forest node, but not all nodes have views:)x" "\n"
  R"x(// - nodes not reachable though current ambiguity selection)x" "\n"
  R"x(// - trivial "wrapping" sequence nodes are abbreviated away)x" "\n"
  R"x(class NodeView {)x" "\n"
  R"x(  // Builds a node representing forest[index], or its target if it is a wrapper.)x" "\n"
  R"x(  // Registers the node in the global map.)x" "\n"
  R"x(  static make(index, parent, abbrev) {)x" "\n"
  R"x(    var node = forest[index];)x" "\n"
  R"x(    if (node.kind == 'sequence' && node.children.length == 1 &&)x" "\n"
  R"x(        forest[node.children[0]].kind != 'ambiguous') {)x" "\n"
  R"x(      abbrev ||= [];)x" "\n"
  R"x(      abbrev.push(index);)x" "\n"
  R"x(      return NodeView.make(node.children[0], parent, abbrev);)x" "\n"
  R"x(    })x" "\n"
  R"x(    return views[index] = new NodeView(index, parent, node, abbrev);)x" "\n"
  R"x(  })x" "\n"
  R"x()x" "\n"
  R"x(  constructor(index, parent, node, abbrev) {)x" "\n"
  R"x(    this.abbrev = abbrev || [];)x" "\n"
  R"x(    this.parent = parent;)x" "\n"
  R"x(    this.children =)x" "\n"
  R"x(        (node.kind == 'ambiguous' ? [ node.selected ] : node.children || []))x" "\n"
  R"x(            .map((c) => NodeView.make(c, this));)x" "\n"
  R"x(    this.index = index;)x" "\n"
  R"x(    this.node = node;)x" "\n"
  R"x(    views[index] = this;)x" "\n"
  R"x()x" "\n"
  R"x(    this.span = this.buildSpan();)x" "\n"
  R"x(    this.tree = this.buildTree();)x" "\n"
  R"x(  })x" "\n"
  R"x()x" "\n"
  R"x(  // Replaces the token sequence in #code with a <span class=node>.)x" "\n"
  R"x(  buildSpan() {)x" "\n"
  R"x(    var elt = document.createElement('span');)x" "\n"
  R"x(    elt.dataset['index'] = this.index;)x" "\n"
  R"x(    elt.classList.add("node");)x" "\n"
  R"x(    elt.classList.add("selectable-node");)x" "\n"
  R"x(    elt.classList.add(this.node.kind);)x" "\n"
  R"x()x" "\n"
  R"x(    var begin = null, end = null;)x" "\n"
  R"x(    if (this.children.length != 0) {)x" "\n"
  R"x(      begin = this.children[0].span;)x" "\n"
  R"x(      end = this.children[this.children.length - 1].span.nextSibling;)x" "\n"
  R"x(    } else if (this.node.kind == 'terminal') {)x" "\n"
  R"x(      begin = document.getElementById(this.node.token);)x" "\n"
  R"x(      end = begin.nextSibling;)x" "\n"
  R"x(    } else if (this.node.kind == 'opaque') {)x" "\n"
  R"x(      begin = document.getElementById(this.node.firstToken);)x" "\n"
  R"x(      end = (this.node.lastToken == null))x" "\n"
  R"x(                ? begin)x" "\n"
  R"x(                : document.getElementById(this.node.lastToken).nextSibling;)x" "\n"
  R"x(    })x" "\n"
  R"x(    var parent = begin.parentNode;)x" "\n"
  R"x(    splice(begin, end, elt);)x" "\n"
  R"x(    parent.insertBefore(elt, end);)x" "\n"
  R"x(    return elt;)x" "\n"
  R"x(  })x" "\n"
  R"x()x" "\n"
  R"x(  // Returns a (detached) <li class=tree-node> suitable for use in #tree.)x" "\n"
  R"x(  buildTree() {)x" "\n"
  R"x(    var elt = document.createElement('li');)x" "\n"
  R"x(    elt.dataset['index'] = this.index;)x" "\n"
  R"x(    elt.classList.add('tree-node');)x" "\n"
  R"x(    elt.classList.add('selectable-node');)x" "\n"
  R"x(    elt.classList.add(this.node.kind);)x" "\n"
  R"x(    var header = document.createElement('header');)x" "\n"
  R"x(    elt.appendChild(header);)x" "\n"
  R"x()x" "\n"
  R"x(    if (this.abbrev.length > 0) {)x" "\n"
  R"x(      var abbrev = document.createElement('span');)x" "\n"
  R"x(      abbrev.classList.add('abbrev');)x" "\n"
  R"x(      abbrev.innerText = forest[this.abbrev[0]].symbol;)x" "\n"
  R"x(      header.appendChild(abbrev);)x" "\n"
  R"x(    })x" "\n"
  R"x(    var name = document.createElement('span');)x" "\n"
  R"x(    name.classList.add('name');)x" "\n"
  R"x(    name.innerText = this.node.symbol;)x" "\n"
  R"x(    header.appendChild(name);)x" "\n"
  R"x()x" "\n"
  R"x(    if (this.children.length != 0) {)x" "\n"
  R"x(      var sublist = document.createElement('ul');)x" "\n"
  R"x(      this.children.forEach((c) => sublist.appendChild(c.tree));)x" "\n"
  R"x(      elt.appendChild(sublist);)x" "\n"
  R"x(    })x" "\n"
  R"x(    return elt;)x" "\n"
  R"x(  })x" "\n"
  R"x()x" "\n"
  R"x(  // Make this view visible on the screen by scrolling if needed.)x" "\n"
  R"x(  scrollVisible() {)x" "\n"
  R"x(    scrollIntoViewV(document.getElementById('tree'), this.tree.firstChild);)x" "\n"
  R"x(    scrollIntoViewV(document.getElementById('code'), this.span);)x" "\n"
  R"x(  })x" "\n"
  R"x()x" "\n"
  R"x(  // Fill #info with details of this node.)x" "\n"
  R"x(  renderInfo() {)x" "\n"
  R"x(    document.getElementById('info').classList = this.node.kind;)x" "\n"
  R"x(    document.getElementById('i_symbol').innerText = this.node.symbol;)x" "\n"
  R"x(    document.getElementById('i_kind').innerText = this.node.kind;)x" "\n"
  R"x()x" "\n"
  R"x(    // For sequence nodes, add LHS := RHS rule.)x" "\n"
  R"x(    // If this node abbreviates trivial sequences, we want those rules too.)x" "\n"
  R"x(    var rules = document.getElementById('i_rules');)x" "\n"
  R"x(    rules.textContent = '';)x" "\n"
  R"x(    function addRule(i) {)x" "\n"
  R"x(      var ruleText = forest[i].rule;)x" "\n"
  R"x(      if (ruleText == null))x" "\n"
  R"x(        return;)x" "\n"
  R"x(      var rule = document.createElement('div');)x" "\n"
  R"x(      rule.classList.add('rule');)x" "\n"
  R"x(      rule.innerText = ruleText;)x" "\n"
  R"x(      rules.insertBefore(rule, rules.firstChild);)x" "\n"
  R"x(    })x" "\n"
  R"x(    this.abbrev.forEach(addRule);)x" "\n"
  R"x(    addRule(this.index);)x" "\n"
  R"x()x" "\n"
  R"x(    // For ambiguous nodes, show a selectable list of alternatives.)x" "\n"
  R"x(    var alternatives = document.getElementById('i_alternatives');)x" "\n"
  R"x(    alternatives.textContent = '';)x" "\n"
  R"x(    var that = this;)x" "\n"
  R"x(    function addAlternative(i) {)x" "\n"
  R"x(      var altNode = forest[i];)x" "\n"
  R"x(      var text = altNode.rule || altNode.kind;)x" "\n"
  R"x(      var alt = document.createElement('div');)x" "\n"
  R"x(      alt.classList.add('alternative');)x" "\n"
  R"x(      alt.innerText = text;)x" "\n"
  R"x(      alt.dataset['index'] = i;)x" "\n"
  R"x(      alt.dataset['parent'] = that.index;)x" "\n"
  R"x(      if (i == that.node.selected))x" "\n"
  R"x(        alt.classList.add('selected');)x" "\n"
  R"x(      alternatives.appendChild(alt);)x" "\n"
  R"x(    })x" "\n"
  R"x(    if (this.node.kind == 'ambiguous'))x" "\n"
  R"x(      this.node.children.forEach(addAlternative);)x" "\n"
  R"x()x" "\n"
  R"x(    // Show the stack of ancestor nodes.)x" "\n"
  R"x(    // The part of each rule that leads to the current node is bolded.)x" "\n"
  R"x(    var ancestors = document.getElementById('i_ancestors');)x" "\n"
  R"x(    ancestors.textContent = '';)x" "\n"
  R"x(    var child = this;)x" "\n"
  R"x(    for (var view = this.parent; view != null;)x" "\n"
  R"x(         child = view, view = view.parent) {)x" "\n"
  R"x(      var indexInParent = view.children.indexOf(child);)x" "\n"
  R"x()x" "\n"
  R"x(      var ctx = document.createElement('div');)x" "\n"
  R"x(      ctx.classList.add('ancestors');)x" "\n"
  R"x(      ctx.classList.add('selectable-node');)x" "\n"
  R"x(      ctx.classList.add(view.node.kind);)x" "\n"
  R"x(      if (view.node.rule) {)x" "\n"
  R"x(        // Rule syntax is LHS := RHS1 [annotation] RHS2.)x" "\n"
  R"x(        // We walk through the chunks and bold the one at parentInIndex.)x" "\n"
  R"x(        var chunkCount = 0;)x" "\n"
  R"x(        ctx.innerHTML = view.node.rule.replaceAll(/[^ ]+/g, function(match) {)x" "\n"
  R"x(          if (!(match.startsWith('[') && match.endsWith(']')) /*annotations*/)x" "\n"
  R"x(              && chunkCount++ == indexInParent + 2 /*skip LHS :=*/))x" "\n"
  R"x(            return '<b>' + match + '</b>';)x" "\n"
  R"x(          return match;)x" "\n"
  R"x(        });)x" "\n"
  R"x(      } else /*ambiguous*/ {)x" "\n"
  R"x(        ctx.innerHTML = '<b>' + view.node.symbol + '</b>';)x" "\n"
  R"x(      })x" "\n"
  R"x(      ctx.dataset['index'] = view.index;)x" "\n"
  R"x(      if (view.abbrev.length > 0) {)x" "\n"
  R"x(        var abbrev = document.createElement('span');)x" "\n"
  R"x(        abbrev.classList.add('abbrev');)x" "\n"
  R"x(        abbrev.innerText = forest[view.abbrev[0]].symbol;)x" "\n"
  R"x(        ctx.insertBefore(abbrev, ctx.firstChild);)x" "\n"
  R"x(      })x" "\n"
  R"x()x" "\n"
  R"x(      ctx.dataset['index'] = view.index;)x" "\n"
  R"x(      ancestors.appendChild(ctx, ancestors.firstChild);)x" "\n"
  R"x(    })x" "\n"
  R"x(  })x" "\n"
  R"x()x" "\n"
  R"x(  remove() {)x" "\n"
  R"x(    this.children.forEach((c) => c.remove());)x" "\n"
  R"x(    splice(this.span.firstChild, null, this.span.parentNode,)x" "\n"
  R"x(           this.span.nextSibling);)x" "\n"
  R"x(    detach(this.span);)x" "\n"
  R"x(    delete views[this.index];)x" "\n"
  R"x(  })x" "\n"
  R"x(};)x" "\n"
  R"x()x" "\n"
  R"x(var selection = null;)x" "\n"
  R"x(function selectView(view) {)x" "\n"
  R"x(  var old = selection;)x" "\n"
  R"x(  selection = view;)x" "\n"
  R"x(  if (view == old))x" "\n"
  R"x(    return;)x" "\n"
  R"x()x" "\n"
  R"x(  if (old) {)x" "\n"
  R"x(    old.tree.classList.remove('selected');)x" "\n"
  R"x(    old.span.classList.remove('selected');)x" "\n"
  R"x(  })x" "\n"
  R"x(  document.getElementById('info').hidden = (view == null);)x" "\n"
  R"x(  if (!view))x" "\n"
  R"x(    return;)x" "\n"
  R"x(  view.tree.classList.add('selected');)x" "\n"
  R"x(  view.span.classList.add('selected');)x" "\n"
  R"x(  view.renderInfo();)x" "\n"
  R"x(  view.scrollVisible();)x" "\n"
  R"x(})x" "\n"
  R"x()x" "\n"
  R"x(// To highlight nodes on hover, we create dynamic CSS rules of the form)x" "\n"
  R"x(//   .selectable-node[data-index="42"] { background-color: blue; })x" "\n"
  R"x(// This avoids needing to find all the related nodes and update their classes.)x" "\n"
  R"x(var highlightSheet = new CSSStyleSheet();)x" "\n"
  R"x(document.adoptedStyleSheets.push(highlightSheet);)x" "\n"
  R"x(function highlightView(view) {)x" "\n"
  R"x(  var text = '';)x" "\n"
  R"x(  for (const color of ['#6af', '#bbb', '#ddd', '#eee']) {)x" "\n"
  R"x(    if (view == null))x" "\n"
  R"x(      break;)x" "\n"
  R"x(    text += '.selectable-node[data-index="' + view.index + '"] ')x" "\n"
  R"x(    text += '{ background-color: ' + color + '; }\n';)x" "\n"
  R"x(    view = view.parent;)x" "\n"
  R"x(  })x" "\n"
  R"x(  highlightSheet.replace(text);)x" "\n"
  R"x(})x" "\n"
  R"x()x" "\n"
  R"x(// Select which branch of an ambiguous node is taken.)x" "\n"
  R"x(function chooseAlternative(parent, index) {)x" "\n"
  R"x(  var parentView = views[parent];)x" "\n"
  R"x(  parentView.node.selected = index;)x" "\n"
  R"x(  var oldChild = parentView.children[0];)x" "\n"
  R"x(  oldChild.remove();)x" "\n"
  R"x(  var newChild = NodeView.make(index, parentView);)x" "\n"
  R"x(  parentView.children[0] = newChild;)x" "\n"
  R"x(  parentView.tree.lastChild.replaceChild(newChild.tree, oldChild.tree);)x" "\n"
  R"x()x" "\n"
  R"x(  highlightView(null);)x" "\n"
  R"x(  // Force redraw of the info box.)x" "\n"
  R"x(  selectView(null);)x" "\n"
  R"x(  selectView(parentView);)x" "\n"
  R"x(})x" "\n"
  R"x()x" "\n"
  R"x(// Attach event listeners and build content once the document is ready.)x" "\n"
  R"x(document.addEventListener("DOMContentLoaded", function() {)x" "\n"
  R"x(  var code = document.getElementById('code');)x" "\n"
  R"x(  var tree = document.getElementById('tree');)x" "\n"
  R"x(  var ancestors = document.getElementById('i_ancestors');)x" "\n"
  R"x(  var alternatives = document.getElementById('i_alternatives');)x" "\n"
  R"x()x" "\n"
  R"x(  [code, tree, ancestors].forEach(function(container) {)x" "\n"
  R"x(    container.addEventListener('click', function(e) {)x" "\n"
  R"x(      var nodeElt = e.target.closest('.selectable-node');)x" "\n"
  R"x(      selectView(nodeElt && views[Number(nodeElt.dataset['index'])]);)x" "\n"
  R"x(    });)x" "\n"
  R"x(    container.addEventListener('mousemove', function(e) {)x" "\n"
  R"x(      var nodeElt = e.target.closest('.selectable-node');)x" "\n"
  R"x(      highlightView(nodeElt && views[Number(nodeElt.dataset['index'])]);)x" "\n"
  R"x(    });)x" "\n"
  R"x(  });)x" "\n"
  R"x()x" "\n"
  R"x(  alternatives.addEventListener('click', function(e) {)x" "\n"
  R"x(    var altElt = e.target.closest('.alternative');)x" "\n"
  R"x(    if (altElt))x" "\n"
  R"x(      chooseAlternative(Number(altElt.dataset['parent']),)x" "\n"
  R"x(                        Number(altElt.dataset['index']));)x" "\n"
  R"x(  });)x" "\n"
  R"x()x" "\n"
  R"x(  // The HTML provides #code content in a hidden DOM element, move it.)x" "\n"
  R"x(  var hiddenCode = document.getElementById('hidden-code');)x" "\n"
  R"x(  splice(hiddenCode.firstChild, hiddenCode.lastChild, code);)x" "\n"
  R"x(  detach(hiddenCode);)x" "\n"
  R"x()x" "\n"
  R"x(  // Build the tree of NodeViews and attach to #tree.)x" "\n"
  R"x(  tree.firstChild.appendChild(NodeView.make(0).tree);)x" "\n"
  R"x(});)x" "\n"
  R"x()x" "\n"
  R"x(// Helper DOM functions //)x" "\n"
  R"x()x" "\n"
  R"x(// Moves the sibling range [first, until) into newParent.)x" "\n"
  R"x(function splice(first, until, newParent, before) {)x" "\n"
  R"x(  for (var next = first; next != until;) {)x" "\n"
  R"x(    var elt = next;)x" "\n"
  R"x(    next = next.nextSibling;)x" "\n"
  R"x(    newParent.insertBefore(elt, before);)x" "\n"
  R"x(  })x" "\n"
  R"x(})x" "\n"
  R"x(function detach(node) { node.parentNode.removeChild(node); })x" "\n"
  R"x(// Like scrollIntoView, but vertical only!)x" "\n"
  R"x(function scrollIntoViewV(container, elt) {)x" "\n"
  R"x(  if (container.scrollTop > elt.offsetTop + elt.offsetHeight ||)x" "\n"
  R"x(      container.scrollTop + container.clientHeight < elt.offsetTop))x" "\n"
  R"x(    container.scrollTo({top : elt.offsetTop, behavior : 'smooth'});)x" "\n"
  R"x(})x" "\n"
  R"x()x" "\n"
  ;
const char HTMLForest_html[] = 
  R"x(<div id="tree"><ul></ul></div>)x" "\n"
  R"x(<pre id="code"></pre>)x" "\n"
  R"x(<div id="info" hidden>)x" "\n"
  R"x(  <header>)x" "\n"
  R"x(    <span id="i_symbol"></span>)x" "\n"
  R"x(    <span id="i_kind"></span>)x" "\n"
  R"x(  </header>)x" "\n"
  R"x(  <section>)x" "\n"
  R"x(    <div id="i_rules"></div>)x" "\n"
  R"x(    <div id="i_alternatives"></div>)x" "\n"
  R"x(  </section>)x" "\n"
  R"x(  <section>)x" "\n"
  R"x(    <div id="i_ancestors"></div>)x" "\n"
  R"x(  </section>)x" "\n"
  R"x(</div>)x" "\n"
  R"x()x" "\n"
  ;
